#include "grafo.h"


/* Reserva */
int grafo::reservar (int n)
{
  return reservar(m,nodos,n);
}


int grafo::reservar (double ** &m,int * &nodos,int n)
{
  int i;
  
  /* Guardamos el orden en el tipo abstracto grafo */
  orden=n;
  
  /* Reservamos memoria para el vector de valores de los nodos */
  if (!(nodos=(int *)malloc(sizeof(int)*orden)))
    {
      return -1;
    }
  /* Reservamos memoria para el numero de filas*/
  if (!(m=(double **)malloc(sizeof(double *)*orden)))	
    {
      return -1;
    }
  /* Reservamos memoria para el numero de columnas */
	for (i=0;i<orden;i++)
	  {
	    if (!(m[i]=(double *)malloc(sizeof(double)*orden)))
	      {
		return -1;
	      }
	  }
	return 0;
}


int reservar_matriz(double ** &m, int n) 
{
  int i,j;
  
  /* Reservamos memoria para el numero de filas*/
  if (!(m=(double **)malloc(sizeof(double *)*n)))
    {
      return -1;
    }
  
  /* Reservamos memoria para el numero de columnas */
  for (i=0;i<n;i++)
    {
      if (!(m[i]=(double *)malloc(sizeof(double)*n)))
	{
	  return -1;
	}
    }
  return 0;
}	


/* Introducir */
void grafo::introducir (void)
{
  introducir (m,nodos,orden);
}


void grafo::introducir (double ** &m,int * &nodos,int orden)
{
  int i,j;
  
  cout << "Valores de los nodos\n\n";
  for (i=0;i<orden;i++)
    {
      cout << "Nodo " << i+1 << ": ";
      cin >> nodos[i];
    }
  
  cout << "\n";
  
  for (i=0;i<orden;i++)
    {
    for (j=0;j<orden;j++)
      {
	/* Si es el mismo nodo */
	if (i==j)
	  {
	    m[i][j]=INFINITO;
	    continue;
	  }
	cout << "Valor del camino " << nodos[i] << " al " << nodos[j] << " (0 si no hay): ";
	cin >> m[i][j];
	
	/* Si no hay camino se guarda un numero grande */
	if (!m[i][j])
	  m[i][j]=INFINITO;
      }
    
    }
}


/* Nuevo nodo */
int grafo::nuevo_nodo (void)
{
  return nuevo_nodo (m,nodos,orden);
}


int grafo::nuevo_nodo (double ** &m,int * &nodos,int &orden)
{
  int i,*aux1;
  
  /* Se usa como auxiliar para reasignar la memoria */
  double **aux;
  
  /* Aumentamos el numero de valores en uno */
  if (!(aux1=(int *)realloc(nodos,sizeof(int)*(orden+1))))
    {
      return -1;
    }
  nodos=aux1;
  
  /* Aumentamos el numero de filas en uno */
  if (!(aux=(double **)realloc(m,sizeof(double *)*(orden+1))))
    {
      return -1;
    }
  m=aux;
  
  for (i=0;i<orden+1;i++)
    {
      /* Aumentamos el numero de columnas de cada fila en uno */
      if (!(aux[i]=(double *)realloc(m[i],sizeof(double)*(orden+1))))
	{
	return -1;
	}
      m[i]=aux[i]; //****
      
    }
  
  /* Aumentamos el orden */
	orden++;
	
	return 0;
}


/* Nuevas Conexiones */
void grafo::nuevas_conexiones(void)
{
  nuevas_conexiones(m,nodos,orden);
}


void grafo::nuevas_conexiones (double ** &m,int * &nodos,int orden)
{
  int i,j;
  
  cout << "Dime el valor del nuevo nodo: ";
  cin >> nodos[orden-1];
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	  /* Si es el mismo nodo */
	  if (i==j)
	    {
	      m[i][j]=INFINITO;
	      continue;
	    }
	  
	  /* Introducimos valores en la ultima fila y/o columna */
	  if (i==orden-1 || j==orden-1)
	    {
	      cout << "Valor del camino " << nodos[i] << " al " << nodos[j] << " (0 si no hay): ";
	      cin >> m[i][j];
	    }
	  
	  /* Si no hay camino se guarda un numero grande */
	  if (!m[i][j])
	    m[i][j]=INFINITO;
	}
    }
}


/* Borrar */
int grafo::borrar (int nodo)
{
  return borrar(m,nodos,orden,nodo);
}


int grafo::borrar (double ** &m,int * &nodos,int &orden,int nodo)
{
  int i,j,k,l,sw=0,*aux1;
  double **aux;
  
  /* Comprobamos si existe el nodo a eliminar */
  for (i=0;i<orden;i++)
    {
    if (nodos[i]==nodo)
      {
	sw=1;
      }
    }
  /* Si no existe devolvemos -1 */
  if (!sw)
    {
      return -1;
    }
  
  if (!(aux1=(int *)malloc(sizeof(int)*(orden-1))))
    {
      return -1;
    }    
  
  /* Reservamos memoria para la matriz temporal */
  if (reservar_matriz(aux,orden-1)==-1)
    {
      return -1;
    }  
  
  /* k y l son los indices de la matriz de orden: orden-1 */
  for (i=0,k=0;i<orden;i++,k++)
    {
      /* Si encontramos la fila nos la saltamos */
      if (nodos[i]==nodo)
	{
	  k--;
	  continue;
	}
      
      /* Copiamos los datos en el vector auxiliar */
      aux1[k]=nodos[i];
      for (j=0,l=0;j<orden;j++,l++)
	{
	  /* Si encontramos la columna nos la saltamos */
	  if (nodos[j]==nodo)
	    {
	      l--;
	      continue;
	    }
	  
                        /* Copiamos los datos en la matriz auxiliar */
	  aux[k][l]=m[i][j];
	}
    }
  
  /* Liberamos la memoria de la matriz y del vector */
  liberar (m,nodos,orden);
  
  orden--;
  
  /* Reservamos memoria para la nueva matriz de orden: orden-1 */
  if (reservar(m,nodos,orden)==-1)
    {
      return -1;
    }
  /* Copiamos de nuevo la matriz y el vector de valores */
  for (i=0;i<orden;i++)
    {
      nodos[i]=aux1[i];
      for (j=0;j<orden;j++)
	{
	m[i][j]=aux[i][j];
	}
    }
  return 0;
}


/* Dijkstra */
int grafo::dijkstra(void)
{
  return dijkstra(m,nodos,orden);
}

/* calcula el camino minimo desde el nodo 1 a los demas */
int grafo::dijkstra(double **m,int *nodos,int orden)
{
  int i,j,x;
  double *d,*s,*p,min;
  
  //	if (!(d=new(double)[orden]) || !(s=new(double)[orden]) || !(p=new(double)[orden]))
  if (!(d=(double *)malloc(sizeof(double)*orden)))
    {
      return -1;
    }
  if (!(s=(double *)malloc(sizeof(double)*orden)))
    {
      return -1;
    }
  if (!(p=(double *)malloc(sizeof(double)*orden)))
    {
    return -1;
    }
  for (i=1;i<orden;i++)
    {
      /* Distancias iniciales desde el nodo 1 al resto */
      d[i]=m[0][i];
      
      /* Para saber que nodos hemos incluido en el conjunto */
      s[i]=0;
      
      /* Para almacenar el camino mas corto desde el nodo 1 */
      p[i]=0;
    }
  d[0]=0;
  s[0]=1;
  p[0]=0;
  for (i=0;i<orden-1;i++)
    {
      min=INFINITO;
      for (j=1;j<orden;j++)
	
	/* Comprobamos cual es el mas cercano al 1 */
	if (d[j]<min && !s[j])
	  {	
	    min=d[j];
	    x=j;
	  }
      
      /* Incluimos en el conjunto el nodo mas cercano */
      s[x]=1;
      for (j=1;j<orden;j++)
	{
	  
	  /* Comprobamos de nuevo las distancias con el nodo */
	  /* mas cercano ya incluido en el conjunto */
	  if (!s[j] && d[j]>(d[x]+m[x][j]))
	    {
	      d[j]=d[x]+m[x][j];
	      /* Guardamos el predecesor */
	      p[j]=x;
	    }
	}
    }
  cout << "\nLas distancias mas cortas desde el nodo " << nodos[0] << " son:\n";
  for (i=1;i<orden;i++)
    
    if((int)d[i]==1000000)
      {
	cout << "\nAl nodo " << nodos[i] << " es: " << "INFINITO";
      }
    else
      {
	cout << "\nAl nodo " << nodos[i] << " es: " << (int)d[i];
      }
  
  cout << "\n\nLos caminos mas cortos desde el nodo " << nodos[0] << " son:\n";
  for (i=1;i<orden;i++)
    {
      camino_dijkstra(p,nodos,i);
    }
  return 0;
}


void grafo::camino_dijkstra(double *p,int *nodos,double i)
{
  double k;
	
  k=i;
  cout << "\nAl nodo " << nodos[(int)i] << " es:\t" << nodos[(int)k];
  do
    {
      /* Vamos sacando los predecesores empezando por el nodo */
      /* destino obviamente hasta sacar el nodo inicial, el 1 */
      k=p[(int)k];
      cout << "\t" << nodos[(int)k];
    }while (k);
}

/* Floyd */
int grafo::floyd(void)
{
  return floyd (m,nodos,orden);
}


int grafo::floyd(double **m,int *nodos,int orden)
{
  double **a,**p;
  int i,j,k;
  
  /* Matriz de los caminos mas cortos entre todos los pares de nodos */
  if (reservar_matriz(p,orden)==-1)
    {
      return -1;
    }  
  
  /* Matriz auxiliar con la que vamos a trabajar */
  if (reservar_matriz(a,orden)==-1)
    {
      return -1;
    }  
  
  for (i=0;i<orden;i++)
    {
    for (j=0;j<orden;j++)
      {
	a[i][j]=m[i][j];
	if (i==j)
	  a[i][j]=0;
	p[i][j]=0.0;
      }
    }
  for (k=0;k<orden;k++)
    {
    for (i=0;i<orden;i++)
      {
	for (j=0;j<orden;j++)
	  {
	    /* Actualizamos la matriz si la distancia a */
	    /* traves del nodo intermedio es menor */
	    if (a[i][j]>(a[i][k]+a[k][j]))
	      {
		a[i][j]=a[i][k]+a[k][j];
	      
		/* Guardamos el predecesor */
		p[i][j]=k+1;
	      }
	  }
      }
    }
  cout << "\n\nLa matriz de las distancias mas cortas es:\n";
  for (i=0;i<orden;i++)
    {
      cout << "\n";
      for (j=0;j<orden;j++)
	{
	  if (a[i][j]==INFINITO)
	    {
	      cout << 0 << "\t";
	    }
	  else
	    {
	      cout << a[i][j] << "\t";
	    }
	}
    }
  cout << "\n\nLos caminos mas cortos entre todos los nodos son:\n";
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	if (i!=j)
	  {
	    cout << "\nCamino entre: " << "el nodo " << nodos[i] << " y el " << nodos[j] << ":    ";
	    cout << nodos[i] << "\t";
	    camino_floyd(p,nodos,i,j);
	    cout << nodos[j];
	  }
	}
    }
  return 0;
}


void grafo::camino_floyd(double **p,int *nodos,double i,double j)
{
  double k;
  
  k=p[(int)i][(int)j];
  if (k)
    {
      /* Muestra los caminos desde el nodo origen al intermedio */
      camino_floyd (p,nodos,i,k-1);
      cout << nodos[(int)k-1] << "\t";

      /* Muestra los caminos desde el nodo intermedio al destino */
      camino_floyd (p,nodos,k-1,j);
    }
}


int grafo::profundidad (void)
{
  return profundidad (m,nodos,orden);
}


int grafo::profundidad (double **m,int *nodos,int orden)
{
  int i;
  int *v;

  /* Va contener los nodos ya visitados */
  //	if (!(v=new(int)[orden]))
  if (!(v=(int *)malloc(sizeof(int)*orden)))
    {
      return -1;
    }
  for (i=0;i<orden;i++)
    {
      v[i]=0;
    }
  for (i=0;i<orden;i++)
    {
      /* Si el nodo todavia no ha sido visitado */
      if (!v[i])
	{
	bp(m,nodos,orden,v,i);
	}
    }
	return 0;
}

/* funcion bp usada en componentes y profundidad */
void grafo::bp(double **m,int *nodos,int orden,int * &v,int i)
{
  int j;
  cout << nodos[i] << "\t";
  
  /* Lo marcamos como visitado */
  v[i]=1;
  for (j=0;j<orden;j++)
    {    
      /* Si hay camino y no es infinito y no ha sido visitado */
      if (m[i][j] && m[i][j]!=INFINITO && !v[j])
	{
	  bp(m,nodos,orden,v,j);
	}
    }
}

int grafo::componentes (void)
{
  return componentes (m,nodos,orden);
}

int grafo::componentes (double **m,int *nodos,int orden)
{
  int i,*v,cont=0;
  
  /* Va contener los nodos ya visitados */
  //	if (!(v=new(int)[orden]))
  if (!(v=(int *)malloc(sizeof(int)*orden)))
    {
      return -1;
    }
  for (i=0;i<orden;i++)
    {
      v[i]=0;
    }
  for (i=0;i<orden;i++)
    {   
      /* Si el nodo todavia no ha sido visitado */
      if (!v[i])
	{
	  /* Cada vez que llamamos al procedimiento bp, */
	  /* aumentamos las componentes conexas en uno */
	  cout << "\nComponente " << cont++ << " : ";
	  bp(m,nodos,orden,v,i);
	}
      
      /* Devolvemos el numero de componentes conexas */
    }  
  return cont;
}


int grafo::cmtpn_dijkstra (void)
{
  return cmtpn_dijkstra(m,orden);
}


int grafo::cmtpn_dijkstra (double **m,int orden)
{
  int i,j,k,x;
  double **d,*s,min;
  
  /* Va a contener los caminos mas cortos entre todos los nodos */
  if (reservar_matriz(d,orden)==-1)
    {
      return -1;
    }
  
  /* Para saber los nodos visitados en cada iteracion */
  if (!(s=(double *)malloc(sizeof(double)*orden)))
    {
    return -1;
    }
	
  for (i=0;i<orden;i++)
    {
      s[i]=0;
      for (j=0;j<orden;j++)
	{
	  d[i][j]=m[i][j];
	}
    }
  for (k=0;k<orden;k++)
    {
      /* En cada iteracion lo ponemos a 0 */
      for (i=0;i<orden;i++)
	{
	  s[i]=0;
	}
      for (i=0;i<orden;i++)
	{
	  min=INFINITO;
	  for (j=0;j<orden;j++)
	    {
	    /* Comprobamos cual es el mas cercano y */
	    /* que no sea el mismo */
	    if (d[k][j]<min && !s[j] && k!=j)
	      {
		min=d[k][j];
		x=j;
	      }
	    }
	  /* Incluimos en el conjunto el nodo mas cercano */
	  s[x]=1;
	  for (j=0;j<orden;j++)
	    {
	      
	      /* Comprobamos de nuevo las distancias con el nodo */
	      /* mas cercano ya incluido en el conjunto */
	      if (!s[j] && d[k][j]>(d[k][x]+m[x][j]) && k!=j)
		{
		  d[k][j]=d[k][x]+m[x][j];
		}
	    }
	}
    }
  cout << "\n\nLa matriz de las distancias mas cortas es:\n";
  for (i=0;i<orden;i++)
    {
      cout << "\n";
      for (j=0;j<orden;j++)
	{
	if (d[i][j]==INFINITO)
	  {
	    cout << 0 << "\t";
	  }
	else
	  {
	    cout << d[i][j] << "\t";
	  }
	}
    }
  return 0;
}

/* Ciclos */
int grafo::ciclos (void)
{
  return ciclos (m,nodos,orden);
}


int grafo::ciclos (double **m,int *nodos,int orden)
{
  int i,j,*v,*aux,sw=0;
  
  /* Va contener los nodos ya visitados */
  if (!(v=(int *)malloc(sizeof(int)*orden)))
    {
      return -1;
    }
  /* Va a mantener los nodos visitados en cada componente conexa */
  if (!(aux=(int *)malloc(sizeof(int)*orden)))
    {
      return -1;
    }
  for (i=0;i<orden;i++)
    {
    v[i]=0;
    for (i=0;i<orden;i++)
      {
	  /* Si el nodo todavia no ha sido visitado */
	  if (!v[i])
			if (!sw)
			  {
			  for (j=0;j<orden;j++)
				  {
				    aux[j]=0;
				  }
				busqueda_ciclos(m,nodos,orden,v,i,aux,sw);
			}
	if (sw)
	  {
		return 1;
	  }
      }
    }
  return 0;
}


void grafo::busqueda_ciclos(double **m,int *nodos,int orden,int * &v,int i,int * &aux,int &sw)
{
  int j,k;
  
  /* Lo marcamos como visitado */
  v[i]=1;
  aux[i]=1;
  for (j=0;j<orden;j++)
    {
      if (!sw)
	/* Si hay camino y no es infinito y no ha sido visitado */
	if (m[i][j] && m[i][j]!=INFINITO && !v[j])
	  {
	    /* Guarda la posicion del nodo al que vamos a ir */
	    k=j;
	    busqueda_ciclos(m,nodos,orden,v,j,aux,sw);
	    /* Cada vez que se produzca una desapilacion */
	    /* marcamos como no visitado el ultimo nodo */
	    /* que habiamos visitado */
	    aux[k]=0;
	  }
	else
	  {
	    /* Si hay camino y no es infinito y ha sido */
	    /* visitado, hay un ciclo */
	    if (m[i][j] && m[i][j]!=INFINITO && aux[j])
	      {
		sw=1;
	      }
	  }
    }
}


/* Visualizar */
void grafo::visualizar(void)
{
  visualizar(m,nodos,orden);
}



void grafo::visualizar(double **m,int *nodos,int orden)
{
  int i,j;
  
  for (i=0;i<orden;i++)
    {
    for (j=0;j<orden;j++)
      {
      if (m[i][j]==INFINITO)
	cout << "\nCamino del nodo " << nodos[i] << " al " << nodos[j] << ": " << 0;
      else
	{
	  cout << "\nCamino del nodo " << nodos[i] << " al " << nodos[j] << ": " << (int)m[i][j];
	}
      }
    }
}

/* Liberar */
grafo::~grafo (void)
{
  liberar (m,nodos,orden);
}


void grafo::liberar (double ** &m,int * &nodos,int orden)
{
  int i;
  
  free (nodos);
  
  for (i=0;i<orden;i++)
    {
      free (m[i]);
    }
  free(m);
}

/* Mostrar */
void grafo::mostrar(int x)
{
  mostrar(m,nodos,orden,x);
}


void grafo::mostrar(double **m,int *nodos,int orden,int x)
{
  int i,j, k, k2;
  for (i=0;i<orden;i++)
    {
      if (x==nodos[i])
	{
	  k=i;
	}
    }
  for (j=k;j<orden;j++)
    {
      if (m[k][j]==1)
	{
	  cout << "\nPuede ir al nodo " << nodos[j];
	  k=j;
//	  mostrar(m,nodos,orden,k);
	}
    }
  
}


/* Prim */
int grafo::prim (void)
{
  return prim(m,nodos,orden);
}


int grafo::prim (double **m,int *nodos,int orden)
{
  int i,j,k,*cercano;
  
  double **ca,*menorcoste,min;
  
  /* Caminos mas cortos */
  //      if (!(menorcoste=new(double)[orden]))
  if (!(menorcoste=(double *)malloc(sizeof(double)*orden)))
    return -1;
  
        /* Nodos mas cercanos */
  //      if (!(cercano=new (int)[orden]))
  if (!(cercano=(int *)malloc(sizeof(int)*orden)))
    return -1;
  
  if (reservar_matriz(ca,orden)==-1)
    return -1;
  
  /* Ponemos a INFINITO los valores de la matriz auxiliar */
  for (i=0;i<orden;i++)
    for (j=0;j<orden;j++)
      ca[i][j]=INFINITO;
  
  for (i=1;i<orden;i++)
    {
      /* Caminos desde el nodo inicial */
      menorcoste[i]=m[0][i];
      
      /* Inicialmente el nodo mas cercano es el nodo 0 */
      cercano[i]=0;
    }
  
  for (i=1;i<orden;i++)
    {
      min=menorcoste[1];
      k=1;
      
      /* Determinamos cual es el nodo mas cercano */
      for (j=2;j<orden;j++)
	if (menorcoste[j]<min)
	  {
	    min=menorcoste[j];
	    k=j;
	  }
      
      /* Actualizamos la matriz de conectividad */
      ca[k][cercano[k]]=m[k][cercano[k]];
      ca[cercano[k]][k]=m[cercano[k]][k];
      
      /* Para no volver a compararlo mas en el futuro */
      menorcoste[k]=INFINITO+10;

      for(j=1;j<orden;j++)
	if ((m[k][j]<menorcoste[j]) && menorcoste[j]<INFINITO+10)                        {
	  /* Actualizamos los valores */
	  menorcoste[j]=m[k][j];
	  cercano[j]=k;
	}
    }
  
  cout << "\nArbol abarcador de recorrido minimo: \n\n";
  
  for (i=0;i<orden;i++)
    for (j=0;j<orden;j++)
      if (ca[i][j]!=INFINITO)
	cout << "\n\tCamino entre el nodo " << nodos[i] << " y el nodo " << nodos[j] << ": " << (int)ca[i][j];
  
  return 0;
}


/* Kruskal */

int grafo::kruskal (void)
{
  return kruskal(m,nodos,orden);
}


int grafo::kruskal (double **m,int *nodos,int orden)
{
  LADO *l;
  int i,j,k=0,*conj;
  double **ca;
  
  /* El vector de estructuras l tendra como mucho una longitud de */
  /* (orden*orden) si todos los lados estuvieran conectados */
  //      if (!(l=LADO new[orden*orden]))
  if (!(l=(LADO *)malloc(sizeof(LADO)*orden*orden)))
    {
      return -1;
    }
  /* Va a contener el arbol abarcador de recorrido minimo */
  if (reservar_matriz(ca,orden)==-1)
    {
      return -1;
    }
  /* Guarda la componente conexa de cada nodo */
  //      if (!(conj=int new [orden]))
  if (!(conj=(int *)malloc(sizeof(int)*orden)))
    return -1;
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	  if (m[i][j]!=INFINITO)
	    {
	      /* Guardamos el camino */
	      l[k].c=m[i][j];
	      
	      /* Guardamos el nodo origen */
	      l[k].n1=i;
	      
	      /* Guardamos el nodo destino */
	      l[k].n2=j;
	      k++;
	    }
	  ca[i][j]=INFINITO;
	}
      
      /* Al principio cada nodo estara en una componente distinta */
      conj[i]=i;
    }
  
  /* Ordenamos el vector de estructuras */
  ordenar(l,k);
	
  k=0;
  i=1;
  do
    {
      /* Si la componente conexa del nodo origen es distinta a la */
      /* del nodo destino */
      if (conj[l[k].n1]!=conj[l[k].n2])
	{
	  /* Guardamos el camino en la matriz auxiliar */
	  ca[l[k].n1][l[k].n2]=l[k].c;
	  i++;
	  
	  /* Unimos los dos nodos */
	  unir (l,conj,orden,k);
	}
      k++;
    } while (i<orden);
  
  cout << "\nArbol abarcador de recorrido minimo: \n\n";
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	  if (ca[i][j]!=INFINITO)
	    {
	      cout << "\n\tCamino entre el nodo " << nodos[i]  << " y el nodo " << nodos[j] << ": " << (int)ca[i][j];
	    }
	}
    }
  return 0;
}


/* funcion de ayuda a kruskal */
void grafo::unir (LADO * &l,int *conj,int orden,int k)
{
  int i;
  
  for (i=0;i<orden;i++)
    
    /* Si la componente conexa del nodo i es igual a la */
    /* componente conexa del nodo destino */
    if (conj[i]==conj[l[k].n2])
      {
      /* Ponemos la componente conexa del nodo i igual a */
      /* la componente conexa del nodo origen */
      conj[i]=conj[l[k].n1];
      }
}

void grafo::ordenar (LADO * &l,int k)
{
  int i,j,aux,nodo1,nodo2;
  double aux2;
  
  for (i=0;i<k;i++)
    {
      aux=i;
      for (j=i+1;j<k;j++)
	{
	  if (l[j].c<l[aux].c)
	    aux=j;
	}
      if (aux!=i)
	{
	  aux2=l[i].c;
	  nodo1=l[i].n1;
	  nodo2=l[i].n2;
	  l[i].c=l[aux].c;
	  l[i].n1=l[aux].n1;
	  l[i].n2=l[aux].n2;
	  l[aux].c=aux2;
	  l[aux].n1=nodo1;
	  l[aux].n2=nodo2;
	}
    }
}



/* Arbol Abarcador */
int grafo::aarm (void)
{
  return aarm(m,nodos,orden);
}


int grafo::aarm (double **m,int *nodos,int orden)
{
  int i,j,k,*lejano;
  double **ca,*mayorcoste,max;
  
  /* Caminos mas largos */
  if (!(mayorcoste=(double *)malloc(sizeof(double)*orden)))
    return -1;
  
        /* Nodos mas lejanos */
  if (!(lejano=(int *)malloc(sizeof(int)*orden)))
    return -1;
  
  if (reservar_matriz(ca,orden)==-1)
    return -1;
  
  /* Ponemos a INFINITO los valores de la matriz auxiliar */
  for (i=0;i<orden;i++)
    
    for (i=0;i<orden;i++)
      for (j=0;j<orden;j++)
	ca[i][j]=INFINITO;
  
  for (i=1;i<orden;i++)
    {
      /* Caminos desde el nodo inicial */
      mayorcoste[i]=m[0][i];
      
      /* Inicialmente el nodo mas lejano es el nodo 0 */
      lejano[i]=0;
    }
  
  for (i=1;i<orden;i++)
    {
      max=0;
      k=0;
      
      /* Determinamos cual es el nodo mas lejano */
      for (j=1;j<orden;j++)
	if (mayorcoste[j]>max && mayorcoste[j]<INFINITO)
	  {
	    max=mayorcoste[j];
	    k=j;
	  }
      
      /* Actualizamos la matriz de conectividad */
      ca[k][lejano[k]]=m[k][lejano[k]];
      ca[lejano[k]][k]=m[lejano[k]][k];
      
      /* Para no volver a compararlo mas en el futuro */
      mayorcoste[k]=INFINITO+10;
      
      for(j=1;j<orden;j++)
	if (mayorcoste[j]==INFINITO)
	  {
	    if (m[k][j]<INFINITO)
	      {
		/* Actualizamos los valores */
		mayorcoste[j]=m[k][j];
		
		lejano[j]=k;
	      }
	  }
	else
	  {
	    if (mayorcoste[j]<INFINITO && m[k][j]>mayorcoste[j] && m[k][j]<INFINITO)
	      
	      /* Actualizamos los valores */
	      mayorcoste[j]=m[k][j];
	    lejano[j]=k;
	  }
      
    }
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	  if (ca[i][j]!=INFINITO)
	    {
	cout << "\n\tCamino entre el nodo " << nodos[i] << " y el nodo " << nodos[j] << ": " << (int)ca[i][j];
	    }
	}
    }
  return 0;
}

/* Arbol Abarcador, guardandolo en un arbol */
int grafo::aarm2 (arbol &tree)
{
  return aarm2(m,nodos,orden,tree);
}


int grafo::aarm2 (double **m,int *nodos,int orden,arbol &tree)
{
  int i,j,k,*lejano;
  double **ca,*mayorcoste,max;
  
  /* Caminos mas largos */
  if (!(mayorcoste=(double *)malloc(sizeof(double)*orden)))
    return -1;
  
        /* Nodos mas lejanos */
  if (!(lejano=(int *)malloc(sizeof(int)*orden)))
    return -1;
  
  if (reservar_matriz(ca,orden)==-1)
    return -1;
  
  /* Ponemos a INFINITO los valores de la matriz auxiliar */
  for (i=0;i<orden;i++)
    
    for (i=0;i<orden;i++)
      for (j=0;j<orden;j++)
	ca[i][j]=INFINITO;
  
  for (i=1;i<orden;i++)
    {
      /* Caminos desde el nodo inicial */
      mayorcoste[i]=m[0][i];
      
      /* Inicialmente el nodo mas lejano es el nodo 0 */
      lejano[i]=0;
    }
  
  for (i=1;i<orden;i++)
    {
      max=0;
      k=0;
      
      /* Determinamos cual es el nodo mas lejano */
      for (j=1;j<orden;j++)
	if (mayorcoste[j]>max && mayorcoste[j]<INFINITO)
	  {
	    max=mayorcoste[j];
	    k=j;
	  }
      
      /* Actualizamos la matriz de conectividad */
      ca[k][lejano[k]]=m[k][lejano[k]];
      ca[lejano[k]][k]=m[lejano[k]][k];
      
      /* Para no volver a compararlo mas en el futuro */
      mayorcoste[k]=INFINITO+10;
      
      for(j=1;j<orden;j++)
	if (mayorcoste[j]==INFINITO)
	  {
	    if (m[k][j]<INFINITO)
	      {
		/* Actualizamos los valores */
		mayorcoste[j]=m[k][j];
		
		lejano[j]=k;
	      }
	  }
	else
	  {
	    if (mayorcoste[j]<INFINITO && m[k][j]>mayorcoste[j] && m[k][j]<INFINITO)
	      
	      /* Actualizamos los valores */
	      mayorcoste[j]=m[k][j];
	    lejano[j]=k;
	  }
      
    }
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	  if (ca[i][j]!=INFINITO)
	    {
	cout << "\n\tCamino entre el nodo " << nodos[i] << " y el nodo " << nodos[j] << ": " << (int)ca[i][j];
	    tree.InsertarRecursivo((int)ca[i][j]);	
	    }
	}
    }
  return 0;
}

