#include "arbol.h"

/* Funcion que busca el abuelo de un nodo dado el valor */
void arbol::nudo::abuelo(nudo *p,int valor)
{
int encontrado=0;
nudo *padre=NULL;
nudo *abuelo=NULL;

//	devuelto=abuelo;
        /* Mientras hayan nodos o se encuentre el elemento */
        while (p || encontrado==1)
        {
                /* Hemos encontrado el nodo */
                if (p->inf==valor)
		    {
                        /* Devolvemos el abuelo del nodo */
			if(abuelo!=NULL)
			    {
 			    cout << "\n\nEl abuelo de " << valor << " es " << abuelo->inf << endl; 
			    break; // salimos porque sino seguiria buscando
			    }
			else // no hay abuelo!
			    {
			    cout << "\n\nEl nodo " << valor << " no tiene abuelo" << endl; 
			    }
			encontrado=1;
			break;
		    }
// sino seguimos buscando el abuelo
                abuelo=padre;
                padre=p;
		
                if (p->inf>valor)
		    {
			if(hi!=NULL) // esto es asi porque sino llegaria a
			// la hoja y pasaria al siguiente que es nulo
			    {
                    	    p=p->hi;
			    }
		    }
                else
		    {
                        if (p->inf<valor)
			    {
			    if(hd!=NULL) // idem para derecha
				{
                                p=p->hd;
				}
        		    }
		    }
	} // fin while
	    

        /* No se ha encontrado */
if(encontrado=0)
    {
    cout << "\nNo se ha encontrado el nodo o el abuelo\n";
//    return -1;
    }
}





/* funcion actualizar, actualiza los campos de la parte privada */
void arbol::nudo::actualizar(nudo * &p)
{
  int cont;
  if (p)
    {
      cont=0;
      altura(p,p->inf,cont);
      p->alt=cont-1;
      cont=0;
      profundidad(p,p->inf,cont);
      p->prof=cont-1;
      cont=0;
      descendientes(p,p->inf,cont);
      p->desc=cont-1;
      hi->actualizar(hi);
      hd->actualizar(hd);
    }
  
}

void arbol::nudo::altura(nudo *p,int num,int &cont)
{
  int aux=0;
  while (p)
    {
      if (p->inf==num)
	{
	  recorre_altura(p,aux,cont); // recorrer1(p,aux,con);
	  break;
	}
      if (p->inf>num)
	{
	  p=p->hi;
	}
      else
	{
	  if (p->inf<num)
	    {
	      p=p->hd;
	    }
	}
    }
}



/* borrados */

int arbol::nudo::borra(int x,nudo * &p)
{
  if (inf > x)
    {
      if (hi != NULL)
        return hi->borra(x,hi);
      else
	{
	  return(0);
	}
    }
  else if (inf < x)
    {
      if (hd != NULL)
        return hd->borra(x,hd);
      else
	{
	  return(0);
	}
    }
  else
    {
      nudo *ptr=p;
      if (hi == NULL)
	{
	  p = hd;
	  delete ptr;
	}
      else if (hd == NULL)
	{
	  p = hi;
	  delete ptr;
	}
      else
	{
	  inf = hi->bor(hi);
	}		 
      return 1;
    }
}    

int arbol::nudo::bor(nudo * &p)
{ 
  if (hd != NULL)
    {
      return hd->bor(hd);
    }
  else
    {
      int x=inf;
      p=hi;
      delete this;
      return x;
    }
}

/* busquedas */

int arbol::nudo::busca(int x)
{
  if (inf > x)
    {
      if (hi != NULL)
	{
        return hi->busca(x);
	}
      else
	{
	  return(0);
	}
    }
  else if (inf < x)
    {
      if (hd != NULL)
	{
        return hd->busca(x);
	}
      else
	{
	  return(0);
	}
    }
  else
    {
    return 1;
    }
}

/* descendientes */
 

void arbol::nudo::descendientes(nudo *p, int valor, int &contador)
{
	while(p)
	  {
	    if (p->inf==valor)
                    {
		      p->recorre_descendientes(p,contador);
		      break;
	            }
	    if (p->inf>valor)
	      {
		p=p->hi;
	      }
	    if (p->inf<valor)
	      {
		p=p->hd;
	      }
	  }		
	
}

void arbol::nudo::descendientes_hojas(nudo *p, int valor, int &contador)
{
	while(p)
	  {
	    if (p->inf==valor)
                    {
		      p->recorre_descendientes_hojas(p,contador);
		      break;
	            }
	    if (p->inf>valor)
	      {
		p=p->hi;
	      }
	    if (p->inf<valor)
	      {
		p=p->hd;
	      }
	  }		
	
}


/* inserta un nuevo nudo en el arbol */
int arbol::nudo::inserta(int x)
{
  if (inf > x)
    {
      if (hi != NULL)
        return hi->inserta(x);
      else
	{
	  hi=new nudo(x);
	  return(1);
	}
    }
  else if (inf < x)
    {
      if (hd != NULL)
        return hd->inserta(x);
      else
	{
	  hd=new nudo(x);
	  return(1);
	}
    }
   else
     return 0;
}

/* liberar recursivo */
void arbol::nudo::liberar (nudo * &p)
{
        /* Si hay nodos */
        if (p)
        {
		if(hi!=NULL)
			{
			hi->liberar (p->hi);
			}
		if(hd!=NULL)
			{
                	hd->liberar (p->hd);
			}

                /* Liberamos la memoria asignada al nodo */
        }
if(p->hi==NULL && p->hd==NULL)
    {
    delete this;
    }
}

void arbol::nudo::maximo(void (*f)(int))
{
  if (hd!=NULL)
    hd->maximo(f);
  else
    f(inf);
}

void arbol::nudo::minimo(void (*f)(int))
{
  if (hi!=NULL)
    hi->minimo(f);
  else
    f(inf);
}

/* PADRE */
void arbol::nudo::padre(nudo *p,int valor)
{
        nudo *padre=NULL;
        nudo *abuelo=NULL;

        /* Mientras hayan nodos */
        while (p)
        {
                /* Hemos encontrado el nodo */
                if (p->inf==valor)
                        /* Devolvemos el abuelo del nodo */
                        if(padre!=NULL)
				{
				cout << padre->inf << endl;
//			        return padre->inf;
				break;
				}
			else
				{
				cout << "\nNotiene padre" ;
				}			

                abuelo=padre;
                padre=p;

                if (p->inf>valor)
			if(hi!=NULL)
				{
                        	p=p->hi;
				}
                else
                        if (p->inf<valor)
				if(hd!=NULL)
				{
                                p=p->hd;
				}
        }

        /* No se ha encontrado */

}







/* num es el valor informativo del nodo a buscar */
void arbol::nudo::profundidad (nudo *p,int num,int &cont)
{
  while (p)
    {
      cont++;
      if (p->inf==num)
	{
	  return;
	}
      if (p->inf>num)
	{
	  if(hi!=NULL)
	    {
	      p=p->hi;
	    }
	}
      else
	{
	  if (p->inf<num)
	    {
	      if(hd!=NULL)
		{
		  p=p->hd;
		}
	    }
	}
    }
  cont=0;
}





/* recorridos, funciones de ayuda */
void arbol::nudo::recorre_descendientes(nudo * &p, int &contador)
{
  contador++;
  if(hi!=NULL)
    {
      hi->recorre_descendientes(hi,contador);
    }
  if(hd!=NULL)
    {
      hd->recorre_descendientes(hd,contador);
    }
}  

/* recorre los descendiantes y cuenta cuantos de ellos son hojas */
void arbol::nudo::recorre_descendientes_hojas(nudo * &p, int &contador)
{
if (hi==NULL && hd==NULL)
    {
    contador++;
    }
else
    {
      if(hi!=NULL)
	{
          hi->recorre_descendientes_hojas(hi,contador);
	}
      if(hd!=NULL)
	{
          hd->recorre_descendientes_hojas(hd,contador);
	}
    }
}  

/* funcion de recorrido auxiliar que sirve para calcular la altura */
void arbol::nudo::recorre_altura (nudo * &p,int aux,int &contador)
{
  if (p!=NULL)
    {
      aux++;
      if (aux>contador)
	{
	  contador=aux;
	  if(hi!=NULL)
	    {
	      hi->recorre_altura (p->hi,aux,contador);
	    }
	  if(hd!=NULL)
	    {
	      hd->recorre_altura (p->hd,aux,contador);
	    }
	}
    }
}


/* recorridos del arbol */    
void arbol::nudo::recorreprefijo(void (*f)(int))
{
  f(inf);
  if (hi!=NULL)
    hi->recorreprefijo(f);
  if (hd!=NULL)
    hd->recorreprefijo(f);
}

void arbol::nudo::recorreinfijo(void (*f)(int))
{
  if (hi!=NULL)
   hi->recorreinfijo(f);
  f(inf);
  if (hd!=NULL)
    hd->recorreinfijo(f);
}


void arbol::nudo::recorrepostfijo(void (*f)(int))
{
  if (hi!=NULL)
   hi->recorrepostfijo(f);
  if (hd!=NULL)
    hd->recorrepostfijo(f);
  f(inf);
}



void arbol::nudo::terminales(nudo *p)
{
        if (p)
        {
                if (!p->hi && !p->hd)
                {
                        cout << "Valor: " << p->inf << endl;
                        getchar();
                }
		if(hi!=NULL)
                terminales(p->hi);
		if(hd!=NULL)
                terminales(p->hd);
        }
}

